/*
 * $Id$
 *
 *  libosgswt is a library that provides an SWT composite
 *  to display an OpenSceneGraph.
 *  Copyright (C) 2006  Stephane GALLAND
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.io.File;
import java.net.URISyntaxException;
import java.net.URL;

import org.arakhne.osg.swt.OSGSWTCanvas;
import org.arakhne.osg.OSGLine;
import org.arakhne.osg.OSGObject;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

/** 
 * A simple testing class.
 *
 * @author St&eacute;phane GALLAND &lt;stephane.galland@utbm.fr&gt;
 * @version $Name$ $Revision$ $Date$
 */
public class OSGSWTViewer {

	public static void main(String[] args) {
		
		//cessnafire.osg is part of OpenSceneGraph-Data
		/*URL osgFile = OSGSWTViewer.class.getResource("cessnafire.osg"); //$NON-NLS-1$
		if (osgFile==null) {
			System.err.println("testing file 'cessnafire.osg' was not found"); //$NON-NLS-1$
			System.exit(1);
		}

		System.out.println("Use file "+osgFile.toExternalForm()); //$NON-NLS-1$
		*/

		Display display = new Display();
		Shell shell = new Shell(display);
		FillLayout shell_layout = new FillLayout();
		shell.setLayout(shell_layout);
		shell.setSize(600, 300);
		shell.setText("SWT viewer for OSG"); //$NON-NLS-1$

		System.err.println( "We are about to create the controls..." ); //$NON-NLS-1$
		OSGSWTCanvas canvas1 = new OSGSWTCanvas( shell, SWT.NONE );
		System.err.println( "Controls created." ); //$NON-NLS-1$

		System.err.println("Creating 3d scene..."); //$NON-NLS-1$
		/*File file = null;
		try {
			file = new File(osgFile.toURI());
			if (!file.exists()) {
				System.err.println(file.toString()+" not found"); //$NON-NLS-1$
				System.exit(1);
			}
		}
		catch (URISyntaxException e) {
			System.err.println(e.toString());
			System.exit(1);
		}
			
		OSGObject complex_obj = new OSGFileObject(file);*/

		OSGObject box = new OSGObject();
		box.addChild( new OSGLine(1.0f,0.0f,0.0f) );
		box.addChild( new OSGLine(0.0f,1.0f,0.0f) );
		box.addChild( new OSGLine(0.0f,0.0f,1.0f) );
		
		//box.addChild(complex_obj);
		
		canvas1.addOSGObject(box);
		System.err.println("Scene created."); //$NON-NLS-1$

		shell.open();
		
		while (!shell.isDisposed()) {
			box.rotate(0.2f, 1f, 0f, 0f);
			canvas1.update();
			
			display.readAndDispatch();			
		}
		display.dispose();
	}

}
